/*


functions:
int get(void* key, void* value, void* error); 
int post(void* key, void* value, void* error); 
int delete(void* key, void* value, void* error); 


PA4 instructions:
This is a library, which will encode and decode your request and response messages.
For example, at the client side this library will encode your request message to the decided
message format, and then send it out to the server process. Similarly, it will decode the
response received from the server, and then hand out the decoded response to the KVClient
module.
Something complimentary will happen at the server end.
Status Codes for request message
GET: 1
PUT: 2
DEL: 3
Status Codes for response message
Success: 200
Error: 400 (with the appropriate error message)
Reasons for error could be GET key not found, DEL key not found etc.

https://moodle.iitb.ac.in/mod/forum/discuss.php?d=13716
The client library really consists of only 3 functions corresponding to the get, put and del. 
Internally, these messages manage encoding the request, sending the message, 
waiting for the reply and returning the appropriate value. 
So, a get API would like like int get(void* key, void* value, void* error); 
The return value is the status code. 
If the code is 200, then get will fill in the value with malloced memory. 
Else, it will malloc some memory into the error pointer and return it. And so on....

*/
#include "KVMessageFormat.h"
#include<stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h> 
#include <netdb.h> 
#include <netinet/in.h> 
#include <stdlib.h> 
#include <string.h> 
#include <unistd.h>
#include <sys/socket.h> 
#include <sys/types.h> 
#include <arpa/inet.h>
struct message *request(char status,char* key,char* value)
{
      if(!status ||(key==NULL && value==NULL) )
    {
        printf("Invalid parameters in request()");
        return NULL;
    }
    struct message *requestMessage= malloc(sizeof(struct message));
    requestMessage->status=status;

    memcpy(requestMessage->key,key,256); //copied the complete key

    if(strlen(requestMessage->key)<256)
    {
        requestMessage->key[strlen(requestMessage->key)]='\0';
    }
    if(value!=NULL)
    {
        memcpy(requestMessage->value,value,256); //copied the complete value
    }
   
    if(strlen(requestMessage->value)<256) //to pad with \0
    {
        requestMessage->value[strlen(requestMessage->value)]='\0';
    }
   
    return requestMessage;
}
void printMessage(struct message *requestMessage)
{
    printf("[Message Generated]\n[[Status:%c]\n[Key:%s]\n[Value:%s]]\n",requestMessage->status,requestMessage->key,requestMessage->value);
    return ;
}